// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2023 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from Circuit.idl.

package com.raritan.idl.pdumodel;

import com.raritan.idl.*;
import com.raritan.util.AsyncRequest;

public interface Circuit_1_0_5 {
  static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Circuit:1.0.5", null);

  public static final int ERR_INVALID_PARAM = 1;

  public static final int ERR_METER_CHANNEL_BUSY = 2;

  public enum Type {
    ONE_PHASE_LN,
    ONE_PHASE_LL,
    ONE_PHASE_LLN,
    THREE_PHASE;
  }

  static public class Config implements Cloneable {
    public int position = 0;
    public com.raritan.idl.pdumodel.Circuit_1_0_5.Type type = com.raritan.idl.pdumodel.Circuit_1_0_5.Type.values()[0];

    public Object clone() {
      Config copy = new Config();

      copy.position = this.position;
      copy.type = this.type;

      return copy;
    }

  }

  public class GetConfigResult {
    public com.raritan.idl.pdumodel.Circuit_1_0_5.Config _ret_;
  }

  GetConfigResult getConfig() throws Exception;

  AsyncRequest getConfig(AsyncRpcResponse<GetConfigResult> rsp);

  AsyncRequest getConfig(AsyncRpcResponse<GetConfigResult> rsp, RpcCtrl rpcCtrl);


  static public class Sensors implements Cloneable {
    public com.raritan.idl.sensors.NumericSensor_4_0_4 current = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 activePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 reactivePower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 apparentPower = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 powerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 phaseAngle = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 displacementPowerFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 activeEnergy = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 unbalancedCurrent = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 crestFactor = null;
    public com.raritan.idl.sensors.NumericSensor_4_0_4 activePowerDemand = null;

    public Object clone() {
      Sensors copy = new Sensors();

      copy.current = this.current;
      copy.activePower = this.activePower;
      copy.reactivePower = this.reactivePower;
      copy.apparentPower = this.apparentPower;
      copy.powerFactor = this.powerFactor;
      copy.phaseAngle = this.phaseAngle;
      copy.displacementPowerFactor = this.displacementPowerFactor;
      copy.activeEnergy = this.activeEnergy;
      copy.unbalancedCurrent = this.unbalancedCurrent;
      copy.crestFactor = this.crestFactor;
      copy.activePowerDemand = this.activePowerDemand;

      return copy;
    }

  }

  public class GetSensorsResult {
    public com.raritan.idl.pdumodel.Circuit_1_0_5.Sensors _ret_;
  }

  GetSensorsResult getSensors() throws Exception;

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp);

  AsyncRequest getSensors(AsyncRpcResponse<GetSensorsResult> rsp, RpcCtrl rpcCtrl);


  public class GetPolesResult {
    public java.util.List<com.raritan.idl.pdumodel.Pole_7_0_0> _ret_;
  }

  GetPolesResult getPoles() throws Exception;

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp);

  AsyncRequest getPoles(AsyncRpcResponse<GetPolesResult> rsp, RpcCtrl rpcCtrl);


  static public class PoleSettings implements Cloneable {
    public com.raritan.idl.pdumodel.PowerLine_2_0_0 line = com.raritan.idl.pdumodel.PowerLine_2_0_0.values()[0];
    public int meterChannel = 0;

    public Object clone() {
      PoleSettings copy = new PoleSettings();

      copy.line = this.line;
      copy.meterChannel = this.meterChannel;

      return copy;
    }

  }

  static public class Settings implements Cloneable {
    public String name = new String();
    public int rating = 0;
    public int ctRating = 0;
    public java.util.List<com.raritan.idl.pdumodel.Circuit_1_0_5.PoleSettings> poleSettings = new java.util.ArrayList<>();

    public Object clone() {
      Settings copy = new Settings();

      copy.name = this.name;
      copy.rating = this.rating;
      copy.ctRating = this.ctRating;
      copy.poleSettings = new java.util.ArrayList<com.raritan.idl.pdumodel.Circuit_1_0_5.PoleSettings>(this.poleSettings);

      return copy;
    }

  }

  public class SettingsChangedEvent extends com.raritan.idl.event.UserEvent {

    static public final TypeInfo typeInfo = new TypeInfo("pdumodel.Circuit_1_0_5.SettingsChangedEvent:1.0.0", com.raritan.idl.event.UserEvent.typeInfo);

    @Override
    protected TypeInfo getClassTypeInfo() {
      return typeInfo;
    }

    public com.raritan.idl.pdumodel.Circuit_1_0_5.Settings oldSettings = new com.raritan.idl.pdumodel.Circuit_1_0_5.Settings();
    public com.raritan.idl.pdumodel.Circuit_1_0_5.Settings newSettings = new com.raritan.idl.pdumodel.Circuit_1_0_5.Settings();
  }

  public class GetSettingsResult {
    public com.raritan.idl.pdumodel.Circuit_1_0_5.Settings _ret_;
  }

  GetSettingsResult getSettings() throws Exception;

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp);

  AsyncRequest getSettings(AsyncRpcResponse<GetSettingsResult> rsp, RpcCtrl rpcCtrl);


  public class SetSettingsResult {
    public int _ret_;
  }

  SetSettingsResult setSettings(com.raritan.idl.pdumodel.Circuit_1_0_5.Settings settings) throws Exception;

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Circuit_1_0_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp);

  AsyncRequest setSettings(com.raritan.idl.pdumodel.Circuit_1_0_5.Settings settings, AsyncRpcResponse<SetSettingsResult> rsp, RpcCtrl rpcCtrl);

}
