// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2023 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from PeripheralDevicePackage.idl.

package com.raritan.idl.peripheral;

import com.raritan.idl.*;

public class PackageInfo_2_0_1 implements Cloneable {

  public enum State {
    NORMAL,
    FW_UPDATE,
    INTERNAL_ERROR,
    CONFIG_ERROR;
  }

  static public class HardwareInfo implements Cloneable {
    public String serial = new String();
    public String packageClass = new String();
    public String model = new String();
    public int minDowngradeVersion = 0;
    public String revision = new String();

    public Object clone() {
      HardwareInfo copy = new HardwareInfo();

      copy.serial = this.serial;
      copy.packageClass = this.packageClass;
      copy.model = this.model;
      copy.minDowngradeVersion = this.minDowngradeVersion;
      copy.revision = this.revision;

      return copy;
    }

  }

  static public class FirmwareInfo implements Cloneable {

    static public class Version implements Cloneable {
      public int majorNumber = 0;
      public int minorNumber = 0;
      public int bootloaderVersion = 0;

      public Object clone() {
        Version copy = new Version();

        copy.majorNumber = this.majorNumber;
        copy.minorNumber = this.minorNumber;
        copy.bootloaderVersion = this.bootloaderVersion;

        return copy;
      }

    }
    public java.util.Date compileDate = new java.util.Date();
    public com.raritan.idl.peripheral.PackageInfo_2_0_1.FirmwareInfo.Version version = new com.raritan.idl.peripheral.PackageInfo_2_0_1.FirmwareInfo.Version();
    public java.util.Date updateDate = new java.util.Date();

    public Object clone() {
      FirmwareInfo copy = new FirmwareInfo();

      copy.compileDate = this.compileDate;
      Object versionCopy = this.version.clone();
      copy.version = (com.raritan.idl.peripheral.PackageInfo_2_0_1.FirmwareInfo.Version) versionCopy;
      copy.updateDate = this.updateDate;

      return copy;
    }

  }
  public com.raritan.idl.peripheral.PackageInfo_2_0_1.State state = com.raritan.idl.peripheral.PackageInfo_2_0_1.State.values()[0];
  public java.util.List<com.raritan.idl.peripheral.PosElement> position = new java.util.ArrayList<>();
  public com.raritan.idl.peripheral.PackageInfo_2_0_1.HardwareInfo hwInfo = new com.raritan.idl.peripheral.PackageInfo_2_0_1.HardwareInfo();
  public com.raritan.idl.peripheral.PackageInfo_2_0_1.FirmwareInfo fwInfo = new com.raritan.idl.peripheral.PackageInfo_2_0_1.FirmwareInfo();

  public Object clone() {
    PackageInfo_2_0_1 copy = new PackageInfo_2_0_1();

    copy.state = this.state;
    copy.position = new java.util.ArrayList<com.raritan.idl.peripheral.PosElement>(this.position);
    Object hwInfoCopy = this.hwInfo.clone();
    copy.hwInfo = (com.raritan.idl.peripheral.PackageInfo_2_0_1.HardwareInfo) hwInfoCopy;
    Object fwInfoCopy = this.fwInfo.clone();
    copy.fwInfo = (com.raritan.idl.peripheral.PackageInfo_2_0_1.FirmwareInfo) fwInfoCopy;

    return copy;
  }

}
