// SPDX-License-Identifier: BSD-3-Clause
//
// Copyright 2023 Raritan Inc. All rights reserved.
//
// This file was generated by IdlC from DsamDevice.idl.

package com.raritan.json_rpc.dsam;

import org.json.*;

import com.raritan.idl.*;
import com.raritan.json_rpc.*;
import com.raritan.util.AsyncRequest;

public class DsamDevice_Proxy extends ObjectProxy implements com.raritan.idl.dsam.DsamDevice {

  public DsamDevice_Proxy(Agent agent, String rid, TypeInfo typeInfo) {
    super(agent, rid, typeInfo);
  }

  public DsamDevice_Proxy(Agent agent, String rid) {
    this(agent, rid, com.raritan.idl.dsam.DsamDevice.typeInfo);
  }

  public static DsamDevice_Proxy staticCast(ObjectProxy proxy) {
    return proxy == null ? null : new DsamDevice_Proxy(proxy.getAgent(), proxy.getRid(), proxy.getStaticTypeInfo());
  }


  @Override
  public GetInfoResult getInfo() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getInfo", params);
    GetInfoResult ret = new GetInfoResult();
    ret._ret_ = com.raritan.json_rpc.dsam.DsamDevice.Info_Codec.decode(result.getJSONObject("_ret_"), agent);
    return ret;
  }

  @Override
  public AsyncRequest getInfo(final AsyncRpcResponse<GetInfoResult> rsp) {
    return getInfo(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getInfo(final AsyncRpcResponse<GetInfoResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getInfo", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetInfoResult ret = new GetInfoResult();
          ret._ret_ = com.raritan.json_rpc.dsam.DsamDevice.Info_Codec.decode(result.getJSONObject("_ret_"), agent);
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public GetPortsResult getPorts() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("getPorts", params);
    GetPortsResult ret = new GetPortsResult();
    ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.dsam.DsamPort>() {{
      final JSONArray array0 = result.getJSONArray("_ret_");
      for (int i0 = 0; i0 < array0.length(); i0++) {
        JSONObject elem0 = array0.getJSONObject(i0);
        final Integer key0 = elem0.getInt("key");
        final com.raritan.idl.dsam.DsamPort value0 = com.raritan.json_rpc.dsam.DsamPort_Proxy.staticCast(ObjectProxy.decode((elem0.isNull("value") ? null : elem0.getJSONObject("value")), agent));
        this.put(key0, value0);
      }
    }};
    return ret;
  }

  @Override
  public AsyncRequest getPorts(final AsyncRpcResponse<GetPortsResult> rsp) {
    return getPorts(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest getPorts(final AsyncRpcResponse<GetPortsResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("getPorts", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          GetPortsResult ret = new GetPortsResult();
          ret._ret_ = new java.util.HashMap<Integer, com.raritan.idl.dsam.DsamPort>() {{
            final JSONArray array0 = result.getJSONArray("_ret_");
            for (int i0 = 0; i0 < array0.length(); i0++) {
              JSONObject elem0 = array0.getJSONObject(i0);
              final Integer key0 = elem0.getInt("key");
              final com.raritan.idl.dsam.DsamPort value0 = com.raritan.json_rpc.dsam.DsamPort_Proxy.staticCast(ObjectProxy.decode((elem0.isNull("value") ? null : elem0.getJSONObject("value")), agent));
              this.put(key0, value0);
            }
          }};
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }

  @Override
  public StartFirmwareUpdateResult startFirmwareUpdate() throws Exception {
    JSONObject params = null;
    final JSONObject result = rpcCall("startFirmwareUpdate", params);
    StartFirmwareUpdateResult ret = new StartFirmwareUpdateResult();
    ret._ret_ = result.getInt("_ret_");
    return ret;
  }

  @Override
  public AsyncRequest startFirmwareUpdate(final AsyncRpcResponse<StartFirmwareUpdateResult> rsp) {
    return startFirmwareUpdate(rsp, RpcCtrl.getDefault());
  }

  @Override
  public AsyncRequest startFirmwareUpdate(final AsyncRpcResponse<StartFirmwareUpdateResult> rsp, final RpcCtrl rpcCtrl) {
    JSONObject params = null;
    return rpcCall("startFirmwareUpdate", params, new AsyncRpcResponse<JSONObject>() {
      @Override
      public void onSuccess(final JSONObject result) {
        try {
          StartFirmwareUpdateResult ret = new StartFirmwareUpdateResult();
          ret._ret_ = result.getInt("_ret_");
          rsp.onSuccess(ret);
        } catch (Exception e) {
          onFailure(e);
        }
      }
      @Override
      public void onFailure(Exception e) {
        rsp.onFailure(e);
      }
    }, rpcCtrl);
  }
}
